#!/usr/bin/env python

#from twisted.internet import selectreactor
#selectreactor.install()

from twisted.internet import defer, protocol, reactor, address, utils
from twisted.internet import interfaces, process, fdesc
from twisted.internet import abstract, threads, task
from twisted.conch.ssh import transport, userauth, connection, common, keys, channel, forwarding, session
from twisted.conch.client import direct
from twisted.conch.insults import insults
from twisted.conch.manhole import Manhole
from twisted.conch.manhole_ssh import ConchFactory, TerminalRealm
from twisted.conch.stdio import ConsoleManhole
from twisted.conch.telnet import TelnetTransport, TelnetBootstrapProtocol
from twisted.application import service
from twisted.python import util, threadable, usage, failure
from twisted.python import log as logging
from twisted.spread import pb, jelly, flavors, banana, util
from twisted.cred.portal import IRealm, Portal
from twisted.cred.checkers import InMemoryUsernamePasswordDatabaseDontUse, AllowAnonymousAccess
from twisted.cred.credentials import UsernamePassword, Anonymous
from twisted.cred.credentials import IUsernamePassword, IAnonymous
from zope.interface import implements

import persistent
import netifaces
from types import *
from FunctionMarshal import *
import new

from sys import argv
import getpass, time, copy
import struct, sys, getpass, os, time, string
import fcntl
from random import choice,randint
import posix, socket, sets
import cStringIO, cPickle, marshal, traceback
import imp
import uuid

#import curses, curses.wrapper

from basics import verbsh,glob

from numpy.oldnumeric import argsort
from numpy import ndarray
from numpy.core.numerictypes import *
import numpy

PickleTypes = [ndarray]

DEFAULTPORT = 8789
orig_path = copy.copy(sys.path)

#if sys.argv[0].split("/")[-1] not in ["TwistedServer"]:
#   USER = getpass.getuser()
#   PASSWORD = getpass.getpass("%s's password: " % (USER))

HOST = os.uname()[1]

global IMPORTS
IMPORTS = {}

if os.path.exists(".Twisted"):
   o = open(".Twisted","r")
   MACHINES = [str(l[:-1].strip()) for l in o.readlines() if l[0] != "#"]
   o.close()
elif os.environ.has_key('TWISTEDSERVERS'):
   MACHINES = os.environ['TWISTEDSERVERS'].split(",")
else:
   MACHINES = []

def twisted_import(name,comps=None,IMPORTS=IMPORTS):
   fo,pn,desc = imp.find_module(name)
   mstat = os.stat(pn)
   print IMPORTS.keys()
   print pn,pn in IMPORTS
   if pn not in IMPORTS or mstat != IMPORTS[pn][1]:
      mload = True
      modobj = imp.load_module(name,fo,pn,desc)
   else:
      mload = False
      modobj = IMPORTS[pn][0]
   if fo: fo.close()
   IMPORTS[pn] = (modobj,mstat)
   if comps == "*":
     s = "from %s import *" % (name)
     if mload: print s
     for k in dir(modobj):
         globals()[k] = getattr(modobj,k)
   elif comps:
     s = "from %s import %s" % (name,comps)
     if mload: print s
     for k in comps.split(","):
       globals()[k] = getattr(modobj,k)
   else:
     s = "import %s" % (name)
     if mload: print s
     globals()[name] = modobj
   print "Done with (re)import."
   sys.stdout.flush()
   return s


def rdarg(argv,key,conv=None,default=None,single=0):
   val = default
   if key in argv:
    if not single:
      val=argv[argv.index(key)+1]
      del argv[argv.index(key):argv.index(key)+2]
      if conv: val=map(conv,[val])[0]
    else:
      del argv[argv.index(key):argv.index(key)+1]
      val = 1
      if default == 1: val=0
   else:
      if conv and val: val=apply(conv,(val,))
   return argv,val

class SimpleTransport(transport.SSHClientTransport):
    def __init__(self,hub=None,user="",password="",host="",lport=0,verb=0,clean=0):
        self.hub = hub
        self.host = host
        self.user = user
        self.password = password
        self.verb = verb
        self.clean = clean
        c = string.letters+string.digits
        self.user2 = "guest"
        self.password2 = "guest"
#        self.user2 = "".join([choice(c) for k in range(randint(10,20))])
#        self.password2 = "".join([choice(c) for k in range(randint(10,20))])
        self.lport = lport
    def verifyHostKey(self, hostKey, fingerprint):
        if self.verb: print 'host key fingerprint: %s' % fingerprint
        return defer.succeed(1) 
    def connectionSecure(self):
        sc = SimpleConnection()
        self.sc = sc
        sc.transport = self
        sc.hub = self.hub
        sc.orighost = self.host
        sc.lport = self.lport
        sc.transport = self
        sc.user2 = self.user2
        sc.password2 = self.password2
        sc.verb = self.verb
        sc.clean = self.clean
        sua = SimpleUserAuth(self.user,sc)
        self.sua = sua
        sua.transport = self
        sua.tried = 0
        sua.password = self.password
        sua.verb = self.verb
        self.requestService(sua)

class SimpleClientFactory(protocol.ClientFactory):
    def __init__(self,hub=None,user="",password="",host="",lport=0,verb=0,clean=0):
        self.hub = hub
        self.host = host
        self.user = user
        self.password = password
        self.lport = lport
        self.verb = verb
        self.clean = clean
    def buildProtocol(self,addr):
        p = self.protocol(hub=self.hub,user=self.user,password=self.password,host=self.host,lport=self.lport,verb=self.verb,clean=self.clean)
        self.p = p
        p.factory = self
        return p

class SimpleUserAuth(userauth.SSHUserAuthClient):
    def getPassword(self,prompt=None):
        return defer.succeed(self.password)
    def getGenericAnswers(self, name, instruction, questions):
        if self.verb:
           print "Name",name
           print "Instruction",instruction
           print "Questions",questions
        answers = []
        self.tried += 1
        if self.tried > 4:
           print "We have a password problem!"
           reactor.callFromThread(reactor.disconnectAll)
           reactor.callFromThread(reactor.stop)
        for prompt, echo in questions:
            if prompt == "Password:":
              answer = self.password
            else:
              if echo: 
                  answer = raw_input(prompt)
              else:
                  answer = getpass.getpass(prompt)
            answers.append(answer)
        return defer.succeed(answers)
    def getPublicKey(self):
        path = os.path.expanduser('~/.ssh/id_rsa') 
        # this works with rsa too
        # just change the name here and in getPrivateKey
        if not os.path.exists(path) or getattr(self, 'lastPublicKey', None):
#            print "whatever"
            # the file doesn't exist, or we've tried a public key
            return
        return keys.getPublicKeyString(path+'.pub')
    def getPrivateKey(self):
        path = os.path.expanduser('~/.ssh/id_rsa')
        return defer.succeed(keys.getPrivateKeyObject(path))

class SimpleConnection(connection.SSHConnection):
    def serviceStarted(self):
        self.localForwards = []
        self.ch1 = InitChannel()
        self.last = None
        self.openChannel(self.ch1)
    def serviceStopped(self):
        lf = self.localForwards
        self.localForwards = []
        [s.loseConnection() for s in lf]

class SSHListenClientForwardingChannel(forwarding.SSHListenClientForwardingChannel): pass

class InitChannel(channel.SSHChannel):
    name = "session"
    def openFailed(self, reason):
        sys.stdout.write("echo failed: %s\n" % (reason))

    def channelOpen(self, ignoredData):
        print self.conn.hub.added, self.conn.hub.added2, len(self.conn.hub.CONNECTORS)
        self.rport = 0
        self.rhost = "None"
        self.use = 0
        self.log = ""
        command = self.conn.hub.COMMAND
        sys.stdout.write(command+"\n")
        d = self.conn.sendRequest(self, 'exec', common.NS(command), wantReply = 0)
        self.conn.hub.STARTED.append(self.conn)
        self.conn.uuid = uuid.UUID(bytes=os.urandom(16),version=4).int
        self.stdout = cStringIO.StringIO()
        self.stderr = cStringIO.StringIO()

#        d.addCallback(self._cbRequest)
#
#    def _cbRequest(self,ignored):
#        self.conn.hub2.added2 += 1
#        self.conn.hub.STARTED.apppend(self.conn)

    def closeReceived(self):
        if not self.conn.hub.clean and self.conn in self.conn.hub.RUNNING:
            self.conn.hub.RUNNING.remove(self.conn)
            if self.conn in self.conn.hub.CONNECTORS:
                print "Popping %r out of CONNECTORS" % (self.conn)
                c,r = self.conn.hub.CONNECTORS.pop(self.conn)
                if c.state == "connected": c.disconnect()
                if self.conn in self.conn.hub.CONNECTORS2:
                   c2,r2 = self.conn.hub.CONNECTORS2.pop(self.conn)
                   if c2.state == "connected": c2.disconnect()
                self.conn.hub.added -= 1
                self.conn.hub.added2 -= 1
            if self.conn in self.conn.hub.TASKS:
                print "Popping %r out of TASKS" % (self.conn)
                otasks = self.conn.hub.TASKS.pop(self.conn)
                [delattr(otask,"assigned") for otask in otasks if hasattr(otask,"assigned")]
                self.conn.hub.tasks.extend(otasks)
            if not self.conn.hub.finish and not self.conn.hub.die:
                print "Open new one!"
                reactor.callLater(1,self.conn.hub.AddHost,self.rhost)
#                self.conn.hub.addhosts.append(self.conn.orighost)

    def dataReceived(self, data):
        self.log = self.log + data
        if self.conn.verb:
           sys.stdout.write('Data from %s(%d):\n' % (self.rhost,self.rport))
           sys.stdout.write( data)
           sys.stdout.flush()
        self.conn.hub.out.write('Data from %s(%d):\n' % (self.rhost,self.rport))
        self.conn.hub.out.write( data)
        self.conn.hub.out.flush()
        self.stdout.write( data)
        data = data.split("\n")
        for line in data:
           if "DONE CLEANING" in line:
              self.conn.hub.RUNNING.append(self.conn)
           elif "No longer running the reactor!" in line:
              self.loseConnection()
#              if self.conn in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self.conn)
           elif "THIS MACHINE IS" in line:
              line = line.strip().split()
              self.rhost = line[3]
              self.rhost = self.conn.orighost
              self.rhostip = line[4][1:-2]
              self.rhostop = line[6][:-1]
           elif "ENTER USERNAME" in line:
              self.write(self.conn.user2+"\n")
           elif "ENTER PASSWORD" in line:
              self.write(self.conn.password2+"\n")
           elif "SSH PORT" in line:
              line = line.strip().split("=")
              self.sport = int(line[1])
              if not (self.conn.hub.finish or self.conn.hub.die):
                    s = reactor.listenTCP(0,
                           forwarding.SSHListenForwardingFactory(self.conn,
                                   (self.rhostip,self.sport),
                                   SSHListenClientForwardingChannel))
                    self.sshlhost = os.uname()[1]
                    self.sshlport = s.getHost().port
                    if 1 or self.conn.verb:
                       text = "Forwarding ssh for local port %d to %s(%s) port %d\n" % (self.sshlport,self.rhost,self.rhostip,self.sport)
                       sys.stdout.write( text)
                    reactor.callFromThread(reactor.wakeUp)
                    s.startReading()
                    self.conn.localForwards.append(s)
           elif "USING PORT" in line:
              line = line.strip().split("=")
              if len(line) == 2:
                 ports = line[1].split()
                 if len(ports) == 1:
                     if not (self.conn.hub.finish or self.conn.hub.die):
                        self.rport = int(line[1])
                        s = reactor.listenTCP(0,
                               forwarding.SSHListenForwardingFactory(self.conn,
                                       (self.rhostip,self.rport),
                                       SSHListenClientForwardingChannel))
                        self.lport = s.getHost().port
                        if 1 or self.conn.verb:
                           text = "Forwarding local port %d to %s(%s) port %d\n" % (self.lport,self.rhost,self.rhostip,self.rport)
                           sys.stdout.write( text)
                        reactor.callFromThread(reactor.wakeUp)
                        s.startReading()
                        self.conn.localForwards.append(s)
                        self.conn.hub.conns.append(self.conn)
                        reactor.callLater(0.1,self.conn.hub.MakeConnector,self.conn)
#                        self.conn.hub.added2 += 1
                        print self.conn.hub.added, self.conn.hub.added2
                 elif len(ports) == 2:
                     if not (self.conn.hub.finish or self.conn.hub.die):
                        self.rport,self.rport2 = map(int,ports)
                        s = reactor.listenTCP(0,
                               forwarding.SSHListenForwardingFactory(self.conn,
                                       (self.rhostip,self.rport),
                                       SSHListenClientForwardingChannel))
                        s2 = reactor.listenTCP(0,
                               forwarding.SSHListenForwardingFactory(self.conn,
                                       (self.rhostip,self.rport2),
                                       SSHListenClientForwardingChannel))
                        self.lport = s.getHost().port
                        self.lport2 = s2.getHost().port
                        if 1 or self.conn.verb:
                           text = "Forwarding local port %d to %s(%s) port %d\n" % (self.lport,self.rhost,self.rhostip,self.rport)
                           text = "Forwarding local port %d to %s(%s) port %d\n" % (self.lport2,self.rhost,self.rhostip,self.rport2)
                           sys.stdout.write( text)
                        reactor.callFromThread(reactor.wakeUp)
                        s.startReading()
                        s2.startReading()
                        self.conn.localForwards.append(s)
                        self.conn.localForwards.append(s2)
                        self.conn.hub.conns.append(self.conn)
                        reactor.callLater(0.1,self.conn.hub.MakeConnector,self.conn)
                        print self.conn.hub.added, self.conn.hub.added2


    def extReceived(self, dataType, data):
        self.log = self.log + data
        text = 'extData from %s(%d):\n' % (self.rhost,self.rport)
        sys.stdout.write( text)
        sys.stdout.write( data)
        sys.stdout.flush()
        self.conn.hub.err.write( text)
        self.conn.hub.err.write( data)
        self.conn.hub.err.flush()
        self.stderr.write( data)
#        self.loseConnection()
#        if self.conn in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self.conn)

    def closed(self):
        self.loseConnection()
        self.stderr.close()
        self.stdout.close()
        print "Closed!"
#        if self.conn in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self.conn)

cwd = os.getcwd()
scwd = cwd.split("/")
op,host = os.uname()[:2]
#if op == "Darwin":
#   if scwd[1] == "Users":
#      scwd[1] = "home/%s" % (host.split(".")[0])
#      cwd = "/".join(scwd)
#   elif scwd[1] == "Volumes":
#      scwd[1:3] = [scwd[2],host.split(".")[0]]
#      cwd = "/".join(scwd)

class TwistedTask(persistent.Persistent,flavors.Copyable):
   def __init__(self,taskid=0,func=None,*args,**kws):
       self.elements = "taskid","func","args","kws","modules","fmodules","path","env","done","ohost","port","host","station","hole"
       if taskid == -1:
          u = uuid.UUID(bytes=os.urandom(16),version=4)
          taskid = u.int
       self.taskid = taskid
       self.ohost = None
       self.port = -1
       if "path" in kws:
          self.path = kws["path"]
          kws.pop("path")
       else:
          self.path = os.getcwd()
       if "host" in kws:
          self.host = kws["host"]
          kws.pop("host")
       if "cleanup" in kws:
          self.cleanup = kws["cleanup"]
          kws.pop("cleanup")
       if "condition" in kws:
          self.setCondition(kws["condition"])
          kws.pop("condition")
#       if str(os.getpid()) not in str(taskid): print taskid
       if type(func) in [StringType]:
          self.func = func
          self.args = cPickle.dumps(args,-1)
          self.kws = cPickle.dumps(kws,-1)
       else:
          T = TransportFunction()
          self.func = {func.__name__:T.MarshalFunction(func)}
          self.args = marshal.dumps(T.Pack(args))
          self.kws = marshal.dumps(T.Pack(kws))
#          func2 = lambda : func(*args,**kws)
#          self.func = {func2.__name__:T.MarshalFunction(func2)}
#       self.args = [(type(a) in ftypes and T.FuncToDict(a)) or a for a in args]
#       self.kws = {}
#       [self.kws.setdefault(a,(type(kws[a]) in ftypes and T.FuncToDict(kws[a])) or kws[a]) for a in kws]
       self.modules = []
       self.fmodules = []
       self.env = None
       self.done = False
       self.imported = False
   def __repr__(self):
       if type(self.func) is DictionaryType: name = self.func.keys()[0]
       else: name = self.func
       return "TwistedTask %r (%s:%d): %s / Done: %r" % (self.taskid,self.ohost,self.port,name,self.done)
   def setPath(self,path):
       self.path = path
   def setEnv(self,env):
       self.env = cPickle.dumps(env,-1)
   def setModules(self,modules):
       self.modules = modules
   def setFromModules(self,fmodules):
       self.fmodules = fmodules
   def setResult(self,result):
       self.result = result
       self.done = True
   def setCondition(self,condition):
       self.condition = condition
   def getCondition(self):
       return self.condition()
   def setResult(self,result):
       self.result = result
       self.done = True
   def uponReturn(self,fn,*args,**kw):
       self.uR = fn
       self.uRargs = args
       self.uRkw = kw

class CopyTask(flavors.Copyable):
   def __init__(self,taskid=0,func=None,*args,**kws):
       self.elements = "taskid","func","args","kws","modules","fmodules","path","env","done","ohost","port","host","station","hole"
       self.taskid = taskid
       self.ohost = None
       self.port = -1
       self.func = func
#       self.args = cPickle.dumps(args,-1)
#       self.kws = cPickle.dumps(kws,-1)
       self.modules = []
       self.fmodules = []
       self.path = os.getcwd()
       self.env = None
       self.done = False
       self.imported = False
   def __repr__(self):
       if type(self.func) is DictionaryType: name = self.func.keys()[0]
       else: name = self.func
       return "TwistedTask %r (%s:%d): %s / Done: %r" % (self.taskid,self.ohost,self.port,name,self.done)
   def setPath(self,path):
       self.path = path
   def setEnv(self,env):
       self.env = cPickle.dumps(env,-1)
   def setModules(self,modules):
       self.modules = modules
   def setFromModules(self,fmodules):
       self.fmodules = fmodules
   def setResult(self,result):
       self.result = result
       self.done = True

class ReceiverTask(flavors.RemoteCopy,TwistedTask):
     pass
pb.setUnjellyableForClass(CopyTask, ReceiverTask)

class EncapsulatedFunction():
    def __init__(self,func,hole=False):
       self.func = func
       self.code = getattr(func,"func_code",None)
       self.dict = getattr(func,"func_dict",{})
       self.globals = getattr(func,"func_globals",{})
       if hole and reactor.running:
          self.open()
    def run(self,*args,**kw):
       sys.stdout.flush()
       return self.func(*args,**kw)
    def __call__(self,*args,**kw):
       if reactor.running:
          self.result = self.run(*args,**kw)
          return self.result
#          reactor.callInThread(self.run,*args,**kw)
#          d = threads.deferToThread( self.run,*args,**kw)
#          d.addCallback(lambda result: setattr(self,"result",result))
#          d.addErrback(lambda result: setattr(self,"result",result.getTraceback()))
#          print "Waiting for result now."
#          while not hasattr(self,"result"): time.sleep(1e-8)
#          return self.result
       else:
          return self.run(*args,**kw)
    def __del__(self):
       self.close()
    def open(self):
       namespace = globals()
       namespace["self"] = self
       self.hole = AddManhole(getpass.getuser(),"",namespace,0)
       print "Opened manhole at",self.hole
    def close(self):
       if hasattr(self,"hole"):
          self.hole.stopListening()
          print "Closing manhole at",self.hole
          sys.stdout.flush()

def EvalTask(task): 
    if getattr(task,"env",None):
       newenviron = cPickle.loads(task.env)
       for item in newenviron:
           print "Loading new environment variable %s = %s" % (item,newenviron[item])
           os.environ[item] = newenviron[item]
    os.chdir(task.path)
    if isinstance(task.func,DictionaryType):
      T = TransportFunction()
      func = task.func[ task.func.keys()[0]]
      name,func = T.UnmarshalFunction(func,globals())
      args = T.Unpack(marshal.loads(task.args),globals())
      kws = T.Unpack(marshal.loads(task.kws),globals())
    else:
      if hasattr(task,"modules"):
         [twisted_import(m) for m in task.modules if m]
      if hasattr(task,"fmodules"):
         [twisted_import(m,"*") for m in task.fmodules if m]
      func = eval(task.func)
      args = cPickle.loads(task.args)
      kws = cPickle.loads(task.kws)
    Efunc = EncapsulatedFunction(func,getattr(task,"hole",False))
    result = Efunc(*args,**kws)
    if hasattr(task,"setResult"): task.setResult(result)
    return result

class TwistedVerbSh(verbsh):
    def wait(self):
        while self.perf.poll() == None:
          time.sleep(0.01)
        return self.perf.poll()

class TestTask:
   def __init__(self):
      self.added = []
      self.fadded = []
      self.modules = []
      self.fmodules = []
   def perspective_lmod(self,smod):
         lmod = cPickle.loads(smod)
         os.chdir(lmod["path"])
         f = open(lmod["name"],"w")
         f.write(lmod["data"])
         f.close()
   def perspective_task(self,otask):
      tstart = time.time()
      print "Got",otask
      sys.stdout.flush()
      try:
         loadavg = os.getloadavg()
         if type(otask.func) is DictionaryType:
            T = TransportFunction()
            func = otask.func[ otask.func.keys()[0]]
            name,func = T.UnmarshalFunction(func,globals())
         else:
            func = otask.func
         taskid = otask.taskid
         sys.stdout.write("Function=%s\n" % (func))
         sys.stdout.flush()
         path = otask.path
         print "Changing current working directory to %s." % (path)
         sys.stdout.flush()
         os.chdir(path)
         sys.path = orig_path + [path]
         sys.stdout.flush()
#         if hasattr(otask,"env"):
#            newenviron = cPickle.loads(otask.env)
#            print "Loading environment variables."
#            for item in newenviron:
#                os.environ[item] = newenviron[item]
         if self.modules:
            [(twisted_import(m),self.added.append(m)) for m in self.modules if m and m not in self.added]
         if self.fmodules:
            [(twisted_import(m,"*"),self.fadded.append(m)) for m in self.fmodules if m and m not in self.fadded]
         if hasattr(otask,"modules"):
            [twisted_import(m) for m in otask.modules if m]
         if hasattr(otask,"fmodules"):
            [twisted_import(m,"*") for m in otask.fmodules if m]
         value = EvalTask(otask)
         value = cPickle.dumps(value,-1)
         pickled = True
         sys.stdout.write("Task %r completed.\n" % (taskid))
         sys.stdout.flush()
         success = True
      except:
         content = sys.stdout = sys.stderr = cStringIO.StringIO()
         traceback.print_exc()
         sys.stdout = sys.__stdout__
         sys.stderr = sys.__stderr__
         pickled = False
         value = content.getvalue()
         sys.stderr.write(value)
         sys.stderr.flush()
         success = False
      if hasattr(otask,"cleanup"): eval(otask.cleanup)()
      tnow = time.time()
      telapse = tnow-tstart
      output = (loadavg,taskid,value,pickled,success)
      return output



#    os.chdir(task.path)
#    return eval(task.func)(*cPickle.loads(task.args),**cPickle.loads(task.kws))

class HubRealm:
    implements(IRealm)
    def setHub(self,hub):
        self.hub = hub
        self.spawn = HubSpawn()
        self.spawn.setHub(self.hub)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.spawn, lambda : None
        else:
            raise NotImplementedError("no interface")

class HubSpawn(pb.Avatar):
   from TwistedHub import TwistedTask, CopyTask
   def setHub(self,hub):
       self.hub = hub
       print "Adopting hub:",hub
   def perspective_info(self):
       info = {}
       info["numrunners"] = len(self.hub.RUNNING)
       info["runners"] = [h.uuid for h in self.hub.TASKS]
       return info
   def perspective_task(self,otasks):
       print "Received:",otasks
       if "reactor.stop" in otasks[0].func:
           self.hub.finish = 1
       else:
           print otasks
           [setattr(otask,"imported",True) for otask in otasks]
           self.hub.tasks.extend(otasks)
       return True

basicNotFinished = lambda d: not (d.called and not d.paused) or \
                        not hasattr(d,"result")

notFinished = lambda d: not (d.called and not d.paused) or \
                        not hasattr(d,"result") or type(d.result) == TupleType

class TwistedHub:
   from TwistedHub import TwistedTask, CopyTask
   def __init__(self,tasks=[],timeout=30,port=0,quiet=0,verb=0,sleeptime=0.1,clean=0,norun=0,wait=0,\
        listen=-1,stayalive=0,user=getpass.getuser(), uid=getpass.getuser(), password=None,gdir=None,\
        machines=MACHINES,modules=[],fmodules=[],namespace=globals(),sshport=0,nostop=0,nice=10,auth=0,\
        standalone=1):
       self.initialize()
       self.standalone = standalone
       if namespace:
          self.namespace=namespace
          self.namespace["self"] = self
       else: self.namespace = locals()
       self.dispatchers = {}
       self.queueback = {}
       self.gdir = gdir
       self.user = user
       self.password = None
       self.auth = auth
       self.sshport = sshport
       machines = [(":" not in machine and [machine,"1"] or machine.split(":")) for machine in machines]
       machines = [machine[0] for machine in machines for j in range(int(machine[1]))]
       md = {}
       for km in machines:
         if km not in md: md[km] = []
         md[km].append(km)
       self.machines = []
       kms = md.keys()
       while kms:
         [self.machines.append( md[km].pop(0)) for km in kms if md[km]]
         [md.pop(km) for km in kms if not md[km]]
         kms = md.keys()
       self.modules = modules
       self.fmodules = fmodules
       self.nostop = nostop
       self.tasks = tasks
       self.completed = []
       self.adding = []
       self.sending = []
       self.watchers = {}
       self.nsend = 0
       self.ncomplete = 0
       self.lport = port
       self.verb = verb
       self.uid = uid
       self.clean = clean
       self.norun = norun
       self.finish = 0
       self.listen = listen
       self.stayalive = stayalive
       self.stalled = 0
       COMMAND = "TwistedStation"
       self.COMMAND = " ".join([COMMAND,"-uid",self.uid])
       self.nicelevel = nice
       if self.nicelevel != None:
          self.COMMAND = " ".join([self.COMMAND,"-nice %d" % (self.nicelevel)])
       if self.gdir:
          self.COMMAND = " ".join([self.COMMAND,"-dir",self.gdir])
       if self.clean:
          self.COMMAND = " ".join([self.COMMAND,"-clean"])
       if self.norun:
          self.COMMAND = " ".join([self.COMMAND,"-norun"])
       if self.modules:
          self.COMMAND = " ".join([self.COMMAND,"-i",",".join(self.modules)])
       if self.fmodules:
          self.COMMAND = " ".join([self.COMMAND,"-f",",".join(self.fmodules)])
       self.wait = wait
       self.sleeptime = sleeptime
       self.ntasks = len(tasks)
       self.timeout = timeout
       self.began = False
       self.done = False
       self.die = False
       pstart = time.time()
       pend = time.time()
       if (pend-pstart) > 180: raise "Time to enter password exceeded!"
       self.pid = os.getpid()
       outc = len(glob("/tmp/hub%d*.out" % (self.pid)))
       if outc: outs = "_"+str(outc)
       else: outs = ""
       self.out = open("/tmp/hub%d%s.out" % (self.pid,outs),"w")
       self.err = open("/tmp/hub%d%s.err" % (self.pid,outs),"w")
       if quiet:
          sys.stdout = self.out
          sys.stderr = self.err
       self.tstart = time.time()
       self.clientFactory = SimpleClientFactory(hub=self,user=self.user,password=self.password,lport=self.lport,verb=0,clean=self.clean)
       self.clientFactory.protocol = SimpleTransport
       self.log = cStringIO.StringIO()
       if 1 or self.verb:
#          from twisted.python import util, threadable, usage, log
          logging.startLogging(self.log,setStdout=0)
       self.reactor = reactor
       self.psize = 10
       tfac = 5
       if self.stayalive and self.standalone: tfac = tfac*4
       if hasattr(reactor.threadpool,"max"):
          self.psize = max([8+tfac*len(self.machines),reactor.threadpool.max])
       else:
          self.psize = 8+tfac*len(self.machines)
       if 1 or standalone:
          self.sshport = AddManhole(self.user,"",self.namespace,self.sshport,now=verb)
#       else:
#          self.sshport = AddManhole("guest","guest",self.namespace,self.sshport,now=verb)
       self.out.write("ssh port = %d\n" % (self.sshport.getHost().port))
       self.out.flush()
#       self.out.write("simple port = %d\n" % (self.simpleport.getHost().port))
#       self.out.flush()
       self.passback = []
       self.addhosts = [m for m in self.machines]
       reactor.callLater(0.1,self.AddNextHost)
       self.watchdeaths = task.LoopingCall(self.WatchDeaths)
       self.watchdeaths.start(1)
       self.hostadd = task.LoopingCall(self.AreWeReady)
       self.hostadd.start(0.25)
       if self.listen >= 0:
          reactor.callLater(0.01,self.Listening)
       if self.standalone:
          reactor.run()
          if quiet:
             sys.stdout = sys.__stdout__
             sys.stderr = sys.__stderr__
          self.out.close()
          self.err.close()
          if not quiet:
             os.remove(self.out.name)
             os.remove(self.err.name)
       elif reactor.running and self.clean:
           print "getting deferred"
           d = defer.Deferred()
           d.addCallback(lambda result: self.FinishClean())
           return d.callback(True)
   def FinishClean(self,*args):
       print "inside deferred"
       print self.clean
       while self.clean != -1:
          print "Waiting for clean to finish."
          time.sleep(1)
       return self.clean
   def WatchDeaths(self):
       if not self.addhosts: return
       self.AddNextHost()
   def GetPass(self,password):
       if password: self.password = password
       elif "pw" in os.environ: self.password = os.environ["pw"]
       elif "pwfile" in os.environ and os.path.exists(os.environ["pwfile"]): self.password = open(os.environ["pwfile"],"r").read().strip()
       else: self.password=getpass.getpass("%s's password: " % (self.user))
   def initialize(self):
#       self.GetPass(password)
       self.TASKS = {}
       self.USE = {}
       self.RESULTS = {}
       self.RUNNING = []
       self.STARTED = []
       self.CONNECTORS = {}
       self.CONNECTORS2 = {}
       self.LC = {}
       self.SSH = {}
       self.KILL = {}
       self.currentloads = {}
       self.conns = []
       self.paused = False
       self.added = 0
       self.added2 = 0
       self.htasks = {}
   def AddNextHost(self):
       if len(self.addhosts):
          reactor.callInThread(self.AddHost,self.addhosts.pop(0))
          if self.clean: reactor.callInThread(self.AddNextHost)
#          reactor.callInThread(self.AddNextHost)
       elif hasattr(self,"hostadd") and self.hostadd.running:
          reactor.callFromThread(hostadd.stop)
   def AddHost(self,host):
       clientFactory = SimpleClientFactory(hub=self,user=self.user,password=self.password,host=host,lport=self.lport,verb=self.verb,clean=self.clean)
       clientFactory.protocol = SimpleTransport
       if host not in self.SSH:
          self.SSH[host] = []
       ssh1 = reactor.connectTCP(host,22,clientFactory,timeout=self.timeout)
       clientFactory.ssh = ssh1
       self.SSH[host].append(ssh1)
       reactor.callInThread(self.sshConnected,host,ssh1)
   def fixConnections(self):
       print "Fix connections?"
       for host in self.SSH:
           bad = []
           [bad.append(j) for j,ssh in enumerate(self.SSH[host]) \
                if ssh.state == "disconnected" or not hasattr(ssh.factory.p.sc,"ch1")]
           if bad:
              print "Fixing %d connections for %s!" % (len(bad),host)
              print "Fixing %d connections for %s!" % (len(bad),host)
              print "Fixing %d connections for %s!" % (len(bad),host)
              print "Fixing %d connections for %s!" % (len(bad),host)
              [self.SSH[host][j].disconnect() for j in bad if self.SSH[host][j].state != "connected"]
              [self.SSH[host].pop(j) for j in bad]
              self.added -= 1
              [reactor.callLater(0.1,self.AddHost,host) for j in bad]
   def sshConnected(self,host,ssh1):
       if ssh1.state != "connected":
          reactor.callLater(0.25,self.sshConnected,host,ssh1)
          return
       if not self.clean:
          reactor.callInThread(self.AddNextHost)
       text = "Added %s (%s)\n" % (host,ssh1.state)
       sys.stdout.write( text)
       self.increment(1)
   def increment(self,x):
       if 1 or not self.added:
          reactor.suggestThreadPoolSize(max([20,self.psize]))
          reactor.threadpool.adjustPoolsize(max([reactor.threadpool.workers,min([reactor.threadpool.max,20])]))
#          print reactor.threadpool.min,
#          print reactor.threadpool.max,
#          print reactor.threadpool.workers,self.psize
#          reactor.threadpool.adjustPoolsize(self.psize)
       if x == 2: self.added2 += 1
       elif x == 1: self.added += 1
       print "inc",self.added,self.added2,len(self.CONNECTORS)
   def Watching(self):
       print "Start Watching Connections!"
       if self.wait:
          self.wa = task.LoopingCall(self.WatchAdded)
          self.wa.start(self.sleeptime)
       else:
          self.wr = task.LoopingCall(self.WatchRunning)
          self.wr.start(self.sleeptime)
   def WatchAdded(self):
       if 0 and self.norun:
          if len(self.STARTED) < len(self.machines):
            return
       else:
          nr = len(self.CONNECTORS)
          if not self.clean and len(self.CONNECTORS) < len(self.machines):
#          if len(self.CONNECTORS) < len(self.machines):
#             if nr != len(self.CONNECTORS):
                hosts = [h.ch1.rhost for h in self.CONNECTORS]
                hosts.sort()
                text = "(%d/%d) %r\n" %  (len(self.CONNECTORS),len(self.machines),hosts)
                sys.stdout.write( text)
                if not self.clean and not self.addhosts:
                   time.sleep(1)
                   self.stalled += 1
                   print "Stalled!",self.stalled
                   if self.stalled >=5:
                      self.fixConnections()
#                nr = len(self.CONNECTORS)
#             return
          elif len(self.RUNNING) == len(self.machines):
             text =  "\nAll %d cylinders firing away!\n" % (len(self.CONNECTORS.keys()))
             sys.stdout.write( text)
             self.began = True
             if not self.clean:
                self.wr = task.LoopingCall(self.WatchRunning)
                self.wr.start(self.sleeptime)
             self.wa.stop()
             if self.clean:
                self.clean = -1
                self.Continue()
   def AddConnectors(self):
       if len(self.conns) == len(self.machines):
#          [reactor.callInThread(self.MakeConnector,host) for host in self.conns]
          reactor.callInThread(self.Watching)
          reactor.callInThread(self.hostconn.stop)
   def MakeConnector(self,host):
       if not (self.finish or self.die):
          rhost = host.ch1.rhost
          rport = host.ch1.rport
          sport = host.ch1.sport
          lport = host.ch1.lport
          lport2 = host.ch1.lport2
          user = host.user2
          password = host.password2
          text = "Creating connector to local ports %d %d.\n" % (lport,lport2)
          sys.stdout.write( text)
          text = "Creating connector to %s:%d (%s,%d) using local ports %d %d.\n" % (rhost,rport,user,sport,lport,lport2)
          self.out.write( text)
          self.out.flush()
          text = "ssh %s@%s -p %d\n" % (user,rhost,sport)
          self.out.write( text)
          self.out.flush()
          factory = pb.PBClientFactory()
          connector = reactor.connectTCP('localhost',lport,factory)
          reactor.callInThread(self.WatchConnector,connector,host,user,password,factory)
   def WatchConnector(self,connector,host,user,password,factory):
       print "login connector", connector.state
       if connector.state != "connected":
          reactor.callLater(0.25,self.WatchConnector,connector,host,user,password,factory)
          return
       d = factory.login(UsernamePassword(user,password))
       reactor.callInThread(self.WatchFactory,d,host,connector)
   def WatchFactory(self,d,host,connector):
       print "watch factory",d
       if not hasattr(d,"result") or not hasattr(d.result,"callRemote"):
          reactor.callLater(0.1,self.WatchFactory,d,host,connector)
          return
       d.addCallback(lambda remote: self.FireItUp(host,connector,remote))
       d.addErrback(self.WhatHappened)
       reactor.callFromThread(reactor.wakeUp)
   def WhatHappened(self,reason):
       print reason
       return False
   def FireItUp(self,host,connector,remote):
       print "Fire it up!",host
       print "fired up?", self.added, self.added2, len(self.CONNECTORS)
       self.TASKS.setdefault(host,[])
       self.RESULTS.setdefault(host,[])
       self.CONNECTORS.setdefault(host,[connector,remote])
       self.RUNNING.append(host)
       lport2 = host.ch1.lport2
       user2 = host.user2
       password2 = host.password2
       factory2 = pb.PBClientFactory()
       connector2 = reactor.connectTCP('localhost',lport2,factory2)
       reactor.callInThread(self.WatchConnector2,connector2,host,user2,password2,factory2)
   def WatchConnector2(self,connector2,host,user2,password2,factory2):
       print "login connector2", connector2.state
       if connector2.state != "connected":
          reactor.callLater(0.25,self.WatchConnector2,connector2,host,user2,password2,factory2)
          return
       d2 = factory2.login(UsernamePassword(user2,password2))
       reactor.callInThread(self.WatchFactory2,d2,host,connector2)
   def WatchFactory2(self,d2,host,connector2):
       print "watch factory2",d2
       if not hasattr(d2,"result") or not hasattr(d2.result,"callRemote"):
          reactor.callLater(0.1,self.WatchFactory2,d2,host,connector2)
          return
       d2.addCallback(lambda remote: self.FireItUp2(host,connector2,remote))
       d2.addErrback(self.WhatHappened)
   def FireItUp2(self,host,connector2,remote2):
       self.CONNECTORS2.setdefault(host,[connector2,remote2])
       print "fired up2?",
       print self.added,self.added2,len(self.CONNECTORS)
       host.ch1.use = 1
       self.increment(2)
   def AreWeReady(self):
       if self.clean or (not len(self.addhosts) and len(self.CONNECTORS) == len(self.CONNECTORS2) == len(self.machines)):
          reactor.callInThread(self.Watching)
          self.hostadd.stop()
   def RunTasks(self,tasks):
       self.tasks.extend(tasks)
       def doterator():
           running = []
           for item in tasks:
               print item
               if not (hasattr(item,"done") and item.done and hasattr(item,"result")):
                  running.append(item)
               yield None
       c = task.cooperate(doterator())
       return c,done
   def WatchSpawn(self):
       if not self.paused and (self.tasks or self.adding):
          self.adding.extend([otask for otask in self.tasks if not hasattr(otask,"condition") or otask.getCondition()])
          [self.tasks.remove(otask) for otask in self.adding if otask in self.tasks]
          hnames = [h.ch1.rhost for h in self.TASKS]
          [self.htasks.setdefault(h,0) for h in hnames]
          running = self.TASKS.keys()
          runningu = {}
          for h in running:
              r = h.ch1.rhost
              if r not in runningu: runningu[r] = []
              runningu[r].append(h)
          runningo = []
          while [v for v in runningu.values() if len(v)]:
              for r in runningu:
                 if runningu[r]:
                    runningo.append(runningu[r].pop(0))
          reactor.callLater(self.sleeptime,self.GoSpawn,runningo)
          self.runningo = [host for host in runningo if host.ch1.use and self.TASKS[host] == []]
   def GoSpawn(self):
       if self.adding:
           for host in self.runningo:
               sname = host.ch1.rhost.split(".")[0]
               atask = None
               for otask in self.adding:
                   if not hasattr(otask,"assigned") and \
                       ((not hasattr(otask,"host") or getattr(otask,"host",None) == sname) or \
                        (not hasattr(otask,"station") or getattr(otask,"station",None) == host.uuid)):
                       otask.assigned = True
                       if 1 or self.verb:
                          print "ASSIGNING %r to %r (%s)" % (otask.taskid,host.uuid,sname)
                       atask = otask
                       self.TASKS[host].append(atask)
                       reactor.callInThread(self.SpawnToHost,host)
                       self.htasks[host.ch1.rhost] += 1
                       break
               if atask:
                  self.adding.remove(atask)
                  reactor.callFromThread(reactor.wakeUp)
                  if not self.adding: break
   def WatchRunning(self):
       self.tnow = time.time()
       if not hasattr(self,"ws"):
          text = "Starting up!\n"
          sys.stdout.write( text)
          print "Running!"
       reactor.callFromThread(reactor.wakeUp)
       if self.norun:
          if len(self.STARTED) < len(self.machines):
             reactor.callInThread(self.Continue)
             return
       else:
          if not len(self.CONNECTORS.keys()):
            return
          if not hasattr(self,"ws"):
             self.ws = task.LoopingCall(self.WatchSpawn)
             self.ws.start(self.sleeptime)
             self.gs = task.LoopingCall(self.GoSpawn)
             self.gs.start(self.sleeptime)
          l = 0
          self.nr0 = 0
          if not self.finish and not self.die:
             l = l + 1
             time.sleep(self.sleeptime)
             nr = len(self.completed)
             if not self.stayalive and nr == self.ntasks: self.finish = 1
             if self.verb>1 and ((self.verb and not (l%40)) or (nr != self.nr0)):
                sys.stdout.write("%d %d %d\n" % (nr,self.ntasks,self.finish))
                sys.stdout.flush()
             self.nr0 = nr
             return
          reactor.callInThread(self.Continue)
   def Continue(self):
       if not self.norun:
          self.wr.stop()
          reactor.callFromThread(self.Gather)
          if self.die:
             text =  "\nDying prematurely with %d tasks!\n" % (len(self.tasks)+len(self.adding))
          else:
             text =  "\nAll done!\n"
          self.ws.stop()
          self.gs.stop()
          self.watchdeaths.stop()
          sys.stdout.write( text)
          sys.stdout.flush()
          reactor.callFromThread(reactor.wakeUp)
#          while len(self.CONNECTORS.keys()) < len(self.machines):
          while (self.added < len(self.machines)) and not self.die:
             text =  "Waiting for remaining %d stations to start up so we can kill them, too...\n" % \
                (len(self.machines)-len(self.CONNECTORS.keys()))
             sys.stdout.write( text)
             sys.stdout.flush()
             reactor.callFromThread(reactor.wakeUp)
             time.sleep(self.sleeptime)
          self.End()
          text =  "Waiting for things to shut down...\n"
          sys.stdout.write( text)
          sys.stdout.flush()
#          while self.RUNNING: time.sleep(sleeptime)
       if self.standalone:
           text = "Can we call reactor.stop yet?\n"
           sys.stdout.write( text)
           text = "Now we can!\n"
           sys.stdout.write( text)
       self.done = True
       self.tend = time.time()
       text = "Time to execute=%f\n" % (self.tend-self.tstart)
       sys.stdout.write( text)
       if not self.nostop: self.Stop()
   def Gather(self):
       results = [result for host in self.RESULTS for result in self.RESULTS[host] if hasattr(result,"done")]
       order = argsort([result.result[2] for result in results])
       results = [results[j] for j in order]
       self.timings = [result.result[0] for result in results]
       self.loads = [result.result[1] for result in results]
       self.indices = [result.result[2] for result in results]
       self.results = [result.result[3] for result in results]
   def Elapsed(self):
       return time.time()-self.tstart
   def rhosts(self):
       hosts = [h.ch1.rhost for h in self.RUNNING]
       hosts.sort()
       return hosts
   def Stop(self):
       if not self.norun:
          [host.ch1.loseConnection() for host in self.RESULTS]
          [host.serviceStopped() for host in self.RESULTS]
          [self.CONNECTORS[connector][0].stopListening() for connector in self.CONNECTORS if self.CONNECTORS[connector][0].listening]
          [self.CONNECTORS2[connector][0].stopListening() for connector in self.CONNECTORS2 if self.CONNECTORS2[connector][0].listening]
       print "Stop Listening to",self.sshport
       self.sshport.stopListening()
       if hasattr(self,"listen") and hasattr(self.listen,"getHost"):
          print "Stop Listening to",self.listen
          self.listen.stopListening()
       if self.standalone:
#          reactor.callFromThread(reactor.disconnectAll)
          print "Stopping reactor!"
          reactor.callFromThread(reactor.stop)
   def End(self):
       sys.stdout.flush()
       self.die = 1
       for host in self.RUNNING:
           if host in self.TASKS:
              if self.TASKS[host] == []:
                 print "Soft landing for ", host.ch1.rhost
                 self.TerminateHost(host)
              else:
                 print "Hard landing for ", host.ch1.rhost
                 self.KillHostChild(host,9)
       while self.RUNNING:
          time.sleep(0.1)
       for host in self.SSH:
           for s in self.SSH[host]:
               if s.state == "connected": s.disconnect()
#                  self.TASKS[host].append(TwistedTask(-1,"reactor.stop"))
#                  reactor.callInThread(self.SpawnToHost,host)
   def TerminateHosts(self):
      [self.TerminateHost(host) for host in self.CONNECTORS2.keys()]
   def TerminateHost(self,host):
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
          if self.verb: print "Need to reconnect?!?!??"
          connector.connect()
      while connector.state != "connected":
           if self.verb: print "Waiting for connection!"
           time.sleep(self.sleeptime)
      d = remote.callRemote("stop")
   def GetLoads(self):
      self.currentloads = {}
      [self.GetLoadForHost(host) for host in self.CONNECTORS2]
   def GetLoadForHost(self,host):
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
          if self.verb: print "Need to reconnect?!?!??"
          connector.connect()
      while connector.state != "connected":
           if self.verb: print "Waiting for connection!"
           time.sleep(self.sleeptime)
      tstart = time.time()
      d = remote.callRemote("load")
      self.currentloads[host] = d
      if self.verb: print "Load for",host,self.currentloads[host]
   def KillHostChildren(self,sig=None):
      [self.KillHostChild(host,sig=sig) for host in self.CONNECTORS2]
   def KillHostChild(self,host,sig=None):
      connector,remote = self.CONNECTORS2[host]
      if connector.state == "disconnected":
          if self.verb: print "Need to reconnect?!?!??"
          connector.connect()
      while connector.state != "connected":
          if self.verb: print "Waiting for connection!"
          time.sleep(self.sleeptime)
      tstart = time.time()
      d = remote.callRemote("kill",sig)
   def CleanTasks(self):
       [self.TASKS[k].pop(0) for k in self.TASKS if self.TASKS[k]]
   def SpawnToHost(self,host):
       if host in self.TASKS:
           time.sleep(self.sleeptime)
           if host not in self.RUNNING:
               self.TASKS.pop(host)
               return 
#               break
           if self.TASKS[host]:
                otask = self.TASKS[host][0]
                ctask = CopyTask()
                [setattr(ctask,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
                cwd = otask.path
                scwd = cwd.split("/")
                op,lhost = os.uname()[:2]
#                if lhost != host.ch1.rhost and op != host.ch1.rhostop:
#                   if op == "Darwin":
#                      if scwd[1] == "Users":
#                         scwd[1] = "home/%s" % (lhost.split(".")[0])
#                         cwd = "/".join(scwd)
#                      elif scwd[1] == "Volumes":
#                         scwd[1:3] = [scwd[2],lhost.split(".")[0]]
#                         cwd = "/".join(scwd)
                ctask.setPath(cwd)
#                if "reactor.stop" not in ctask.func: ctask.setEnv(os.environ)
                if self.verb:
                   text = "sending %r to %s(%d<-%d)\n" % (ctask.taskid,host.ch1.rhost,host.ch1.rport,host.ch1.lport)
                   sys.stdout.write( text)
                while host not in self.CONNECTORS:
                   if verb:
                      print "Waiting for connector?"
                      sys.stdout.flush()
                   time.sleep(self.sleeptime)
                connector,remote = self.CONNECTORS[host]
                if connector.state == "disconnected":
                    if self.verb: print "Need to reconnect?!?!??"
                    connector.connect()
                while connector.state != "connected":
                     if self.verb: print "Waiting for connection!"
                     time.sleep(self.sleeptime)
                tstart = time.time()
                d = remote.callRemote("task",ctask)
                host.lasttask = otask
                host.last = d
                host.last.done = False
                if self.verb: print "Waiting for result",otask.taskid
                if "reactor.stop" not in ctask.func:
                   d.addCallback(lambda result: self.WaitForHost(host,time.time()-tstart))
                   d.addErrback(lambda reason: (reason.value))
#                   if host not in self.watchers:
#                      self.watchers[host] = task.LoopingCall(self.WaitForHost,host)
#                   self.watchers[host].start(self.sleeptime)
                reactor.callFromThread(reactor.wakeUp)
                if "reactor.stop" in otask.func:
                    self.TASKS[host].remove(otask)
                    self.TASKS.pop(host)
#                else:
#                    self.watchers[host] = task.LoopingCall(self.WaitForHost,host)
#                    self.watchers[host].start(self.sleeptime)
   def HostsOn(self):
       return [h for h,v in self.TASKS.items() if v]
   def FlushHosts(self):
       return [reactor.callInThread(self.WaitForHost,h) for h in self.HostsOn() if hasattr(h.last,"result")]
   def TasksOn(self):
       return [v[0] for h,v in self.TASKS.items() if v]
   def WaitForHost(self,host,telapse):
#       if not self.TASKS[host]:
#          self.watchers[host].stop()
#          return
       otask = self.TASKS[host][0]
       d = host.last
#       if not (d.called and not d.paused) or not hasattr(d,"result") or type(d.result) == TupleType:
#           return
       self.ncomplete = self.ncomplete + 1
       if not otask.imported:
          if host in self.RESULTS: self.RESULTS[host].append(d)
          else: self.RESULTS.setdefault(host,[d])
       if self.verb: print "Got result for",otask.taskid
       if hasattr(d,"result"):
          results = [telapse] + list(d.result)
          if results[4]: results[3] = cPickle.loads(results[3])
#          host.timing = results[0]
#          host.load = results[1][0]
          otask.setResult(results)
          print otask
          if self.verb: print results
          self.completed.append(otask)
          if self.verb:
             sys.stdout.write("%s\n" % (str(d.result)))
             sys.stdout.write("Time to execute for %r was %f.\n" % (otask.taskid,results[0]))
          sys.stdout.flush()
          self.TASKS[host].pop(0)
          if otask.imported:
              if self.verb: print "Sending back",otask.taskid
#              self.queueback.setdefault(otask)
              self.QueueBack(otask)
#              reactor.callInThread(self.QueueBack,otask)
              reactor.callFromThread(reactor.wakeUp)
       elif self.RUNNING:
          sys.stdout.write("Reinserting the task into the queue!\n")
          sys.stdout.flush()
          delattr(otask,"assigned")
          delattr(host,"lasttask")
          self.tasks.insert(0,otask)
          self.TASKS[host].pop(0)
       else:
          sys.stdout.write("Ran out of connected stations!\n")
          sys.stdout.flush()
          reactor.callFromThread(self.End)
          reactor.callFromThread(self.Stop)
#       if otask.imported:
#          while not hasattr(otask,"sent"):
#            if self.verb: print "Waiting for send back!"
#            time.sleep(self.sleeptime)
#       if host in self.watchers: self.watchers[host].stop()
       host.last.done = True
   def Listening(self):
       self.realm = HubRealm()
       self.realm.setHub(self)
       self.portal = Portal(self.realm)
       if self.auth:
          print "Access set to",self.user
          checker = InMemoryUsernamePasswordDatabaseDontUse()
          checker.addUser(self.user,self.password)
       else:
          print "Access set to anonymous"
          checker = InMemoryUsernamePasswordDatabaseDontUse()
          checker.addUser("anonymous","anonymous")
       self.portal.registerChecker(checker)
       self.listen = reactor.listenTCP(self.listen, pb.PBServerFactory( self.portal))
       port = self.listen.getHost().port
       sys.stdout.write("HUB PORT=%d\n" % (port))
       sys.stdout.flush()
       self.out.write("HUB PORT=%d\n" % (port))
       self.out.flush()
   def QueueBack(self,otask):
       self.queueback.setdefault(otask)
       dispatcher = otask.taskid
       print "Making new connection back to dispatcher",dispatcher
       factory = pb.PBClientFactory()
       connector = reactor.connectTCP(otask.ohost,otask.port,factory)
       if self.auth:
          d = factory.login(UsernamePassword(self.user,self.password))
       else:
          d = factory.login(UsernamePassword("anonymous","anonymous"))
       d.addCallback(lambda result: self.AddDispatcher(otask,result,connector))
       reactor.callFromThread(reactor.wakeUp)
       return d
   def AddDispatcher(self,otask,result,connector):
       dispatcher = (otask.ohost,otask.port)
       print "Got new dispatcher",otask.taskid
       self.dispatchers[otask.taskid] = result,connector
       self.SendBackOne(otask)
   def SendBackOne(self,otask):
       dispatcher = otask.taskid
       if self.verb: print dispatcher in self.dispatchers
       if dispatcher not in self.dispatchers: return
       remote,connector = self.dispatchers[dispatcher]
       if self.verb: print "Sending back:",otask.taskid,otask
       if self.verb: print "Over port:",otask.port
       if self.verb: print "State:",dispatcher, connector.state
       result = otask.result
       presult,p = cPickle.dumps(result,-1),1
       s = remote.callRemote("result",otask.taskid,presult,p)
       s.addCallback(lambda result: self.SentBackOne(otask))
   def SentBackOne(self,otask):
       remote,connector = self.dispatchers.pop(otask.taskid)
       self.queueback.pop(otask)
       connector.disconnect()
       print "Sent back",otask
       otask.sent = True

class HubAvatar(pb.Avatar):
    def __init__(self,hub):
        self.hub = hub
    def perspective_func(self,otask):
        task = TwistedTask()
        [setattr(task,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
        if self.hub.verb: print "Got:",task
        self.hub.addTask(task)
        while not hasattr(task,"result") or not hasattr(task.result,"result") or \
               not isinstance(task.result,pb.RemoteReference):
            if self.hub.verb: print hasattr(task,"result")
            time.sleep( self.hub.sleeptime)
            if self.hub.verb: print "Waiting for results for",task
        if self.hub.verb: print hasattr(task,"result")
        return task.result

class TaskRealm:
    implements(IRealm)
    def __init__(self,dispatcher):
        self.dispatcher = dispatcher
        self.receive = TaskResult( dispatcher)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.receive, lambda : None
        else:
            raise NotImplementedError("no interface")

class TaskResult(pb.Avatar):
   def __init__(self,dispatcher):
       self.dispatcher = dispatcher
   def perspective_result(self,taskid,result,p):
       print "Got result for task",taskid
       if p: result = cPickle.loads(result)
       sys.stdout.flush()
       if taskid in self.dispatcher.iq:
          otask = self.dispatcher.iq[taskid]
          otask.setResult(result)
          reactor.callLater(0.01,self.dispatcher.ClearTasks,[otask])
          reactor.callFromThread(reactor.wakeUp)
          return otask.taskid
       else:
          return -1

class HubDispatch:
   def __init__(self,tasks,hub,user=None,password=None,namespace=None,sleeptime=0.1,\
                verb=0,mport=0,restart=0,stayalive=0,running=0):
       self.tasks = tasks
       ntasks = len(self.tasks)
       self.ntasks = len(self.tasks)
       self.verb = verb
       self.twaits = {}
       self.completed = []
       self.hub = hub
       self.user = user
       self.password = password
       if self.user and self.password == None:
          self.password = getpass.getpass("%s's password:" % (self.user))
       self.sleeptime = sleeptime
       self.mport = mport
       if namespace:
          self.namespace=namespace
          self.namespace["self"] = self
       else: self.namespace = locals()
       self.manhole = None
       reactor.callInThread(self.Manhole)
       self.notdone = True
       self.alreadyrunning = reactor.running
       if reactor.running or running:
           self.stayalive = 1
       else:
           self.stayalive = stayalive
       reactor.callInThread(self.Start)
       print "Reactor already running?",reactor.running
       if reactor.running:
          while not hasattr(self,"connector") or self.connector.state != "connected":
             time.sleep(self.sleeptime)
          self.check = task.LoopingCall(self.Check)
          self.check.start(self.sleeptime)
          self.Spin()
          if self.manhole: self.StopManhole()
          print "ALL DONE!"
       if not reactor.running:
          print "Starting the reactor!"
          reactor.run()
   def Spin(self,*args,**kw):
       print "Spinning now!"
       while self.notdone:
          time.sleep(self.sleeptime)
          reactor.callFromThread(reactor.wakeUp)
       print "Spinning down!"
       self.connector.disconnect()
       if hasattr(self,"listen"): self.listen.loseConnection()
       return self.notdone
   def StopManhole(self):
       reactor.callInThread(self.manhole.stopListening)
       while self.manhole.connected:
             time.sleep(self.sleeptime)
   def Check(self):
       self.notdone = len(self.completed) < self.ntasks
   def Manhole(self):
       if self.user:
          user,password = self.user,self.password
       else:
          user,password = getpass.getuser(),""
       self.manhole = AddManhole(user,password,namespace=self.namespace,port=self.mport)
       print "Manhole at",self.manhole
   def Problem(self,result):
       print dir(result)
       logging.err(result)
       return False
   def Start(self):
       self.factory = pb.PBClientFactory()
       print self.factory
       print "Connecting to hub %s:%d" % (self.hub[0],self.hub[1])
       self.connector = reactor.connectTCP(self.hub[0],self.hub[1],self.factory)
       reactor.callFromThread(reactor.wakeUp)
       if self.user:
          c = UsernamePassword(self.user,self.password)
       else:
          print "anonymous","anonymous"
          c = UsernamePassword("anonymous","anonymous")
       d = self.factory.login(c)
       reactor.callFromThread(reactor.wakeUp)
       print self.connector.state,hasattr(d,"callRemote")
#       self.IsConnected(d)
       d.addCallback(lambda result: self.CheckConnected(result))
       d.addErrback(lambda reason: self.Problem(reason))
       reactor.callFromThread(reactor.wakeUp)
#       self.Spin()
       return d
#       print d
#       while not hasattr(d,"result") or self.connector.state != "connected":
#           time.sleep(self.sleeptime+1)
#           print d
#       self.GetInfo(d.result)
   def IsConnected(self,result):
       print "begin looping call"
       print self.connector.state,hasattr(result,"callRemote")
       self.cconnect = task.LoopingCall(self.CheckConnected,result)
       self.cconnect.start(self.sleeptime)
#       d = threads.deferToThread(self.Spin)
#       d.addCallback(lambda x: self.Spin())
#       d.callback(True)
#       return d
   def CheckConnected(self,result):
       reactor.callFromThread(reactor.wakeUp)
#       if hasattr(result,"result"):
#          result = result.result
       print self.connector.state,hasattr(result,"callRemote")
       if self.connector.state == "connected" and hasattr(result,"callRemote"):
#          reactor.callInThread(self.GetInfo,result)
          return self.GetInfo(result)
#          print "stopping?",self.connector.state
#          self.cconnect.stop()
   def NewInfo(self):
       d = self.remote.callRemote("info")
       d.addCallback(lambda result: self.HaveInfo(result,simple=1))
       d.addErrback(self.Problem)
   def GetInfo(self,result):
       print "info",self.connector.state,result
       self.remote = result
       d = self.remote.callRemote("info")
       d.addCallback(self.HaveInfo)
       d.addErrback(self.Problem)
       reactor.callFromThread(reactor.wakeUp)
       return d
   def HaveInfo(self,result,simple=0):
       self.hubinfo = result
       while "numrunners" not in self.hubinfo:
          reactor.callFromThread(reactor.wakeUp)
          print self.hubinfo
       self.numrunners = self.hubinfo["numrunners"]
       self.runners = self.hubinfo["runners"]
#       print "Number of runners=",self.numrunners
       if simple: return
#       if self.tasks[0].func == "reactor.stop":
#         self.tasks = self.numrunners * self.tasks[:1]
       print "Number of runners in the Hub=",self.numrunners
#       print self.runners
       tfac = 5
       if hasattr(reactor.threadpool,"max"):
          reactor.suggestThreadPoolSize(max([5+tfac*self.numrunners,reactor.threadpool.max]))
          print reactor.threadpool.min,
          print reactor.threadpool.max,
          print reactor.threadpool.workers
          reactor.threadpool.adjustPoolsize(max([reactor.threadpool.workers,min([reactor.threadpool.max,20])]))
       else:
          reactor.suggestThreadPoolSize(5+tfac*self.numrunners)
          reactor.threadpool.adjustPoolsize(max([reactor.threadpool.workers,20]))
#       self.Scan()
#       d = defer.Deferred()
#       d.addCallback(lambda result: self.Listening())
#       d.addCallback(lambda result: self.CheckListen())
#       d.addErrback(lambda reason: self.Problem(reason))
#       d.callback(True)
#       return d

       reactor.callInThread(self.Listening)
#       reactor.callInThread(self.CheckListen)
#       self.lcheck = task.LoopingCall(self.CheckListen)
#       self.lcheck.start(self.sleeptime)
   def CheckListen(self):
       if not hasattr(self,"listen") or not self.listen.getHost():
          print "No listening yet?"
          reactor.callLater(1.0,self.CheckListen)
          return
#       if not self.listen.port: return
#       print "we have a listening?"
#       print self.listen,
#       print self.listen.getHost()
#       print self.listen.getHost().host
#       print self.listen.getHost().port
#       print "Now go!",len(self.tasks)
       reactor.callFromThread(reactor.wakeUp)
       if self.tasks:
          self.Scan()
#             self.Spin()
   def Send(self):
       if not hasattr(self.remote,"callRemote"): return
       self.NewInfo()
       if self.ntasks == 1 and len(self.tasks) == 1 and "reactor.stop" not in self.tasks[0].func and hasattr(self.tasks[0],"all"):
          print "Sending task to all stations!"
          stasks = [copy.copy(self.tasks[0]) for h in self.runners]
          [setattr(stask,"taskid",uuid.UUID(bytes=os.urandom(16),version=4).int) for h,stask in zip(self.runners,stasks)]
          [setattr(stask,"station",h) for h,stask in zip(self.runners,stasks)]
          print [getattr(stask,"station") for h,stask in zip(self.runners,stasks)]
          self.ntasks = len(stasks)
          self.tasks.extend(stasks)
          self.tasks.pop(0)
       ngo = self.numrunners - len(self.queued)
       stasks = [t for t in self.tasks[:ngo] if t not in self.queued]
       if stasks:
           if self.verb: print "Going to send %d tasks" % (len(stasks))
           [self.queued.setdefault(otask) for otask in stasks]
           [self.tasks.remove(stask) for stask in stasks]
           [self.iq.setdefault(otask.taskid,otask) for otask in stasks]
           reactor.callInThread(self.Dispatch,stasks)
           reactor.callFromThread(reactor.wakeUp)
   def Scan(self):
       self.queued = {}
       self.iq = {}
       self.nr = 0
       self.ws = task.LoopingCall(self.Send)
       self.ws.start(self.sleeptime)
       self.scancheck = task.LoopingCall(self.ScanCheck)
       self.scancheck.start(self.sleeptime)
   def ScanCheck(self):
       reactor.callFromThread(reactor.wakeUp)
       if self.tasks:
          self.nr += 1
          if self.verb and not (self.nr%40):  print len(self.tasks),len(self.queued)
          return 
       if self.ws.running:
          self.ws.stop()
          print "stopping looping"
       reactor.callFromThread(reactor.wakeUp)
       self.wqcount = 0
       self.wq = task.LoopingCall(self.WaitForQueue)
       self.wq.start(self.sleeptime)
       if self.scancheck.running:
          self.scancheck.stop()
   def WaitForQueue(self):
#       if [q for q in self.queued if "reactor.stop" in q.func]:
       if self.connector.state == "disconnected":
          reactor.callLater(0.01,reactor.stop)
       if [q for q in self.queued if not q.done]: return
       reactor.callFromThread(reactor.wakeUp)
       print "Queue complete. Can stop now!"
       self.wq.stop()
       self.Stop()
   def Stop(self):
       print "Time to stop."
       if self.manhole and not self.alreadyrunning: reactor.callInThread(self.StopManhole)
       reactor.callFromThread(reactor.wakeUp)
       self.Check()
       if hasattr(self,"listen"):
          self.listen.stopListening()
       if self.stayalive:
          print "let's see if we can keep the reactor alive"
       elif reactor.running:
          reactor.callFromThread(reactor.disconnectAll)
          print "Stopping!"
#          reactor.callLater(0.1,reactor.stop)
          self.wd = task.LoopingCall(self.WaitForDisconnect)
          self.wd.start(self.sleeptime)
   def WaitForDisconnect(self):
       if self.connector.state == "disconnected":
           reactor.callFromThread(reactor.stop)
   def Listening(self,otask=None):
       realm = TaskRealm(self)
       portal = Portal(realm)
       checker = InMemoryUsernamePasswordDatabaseDontUse()
       if self.user:
          checker.addUser(self.user,self.password)
       else:
          c = checker.addUser("anonymous","anonymous")
       portal.registerChecker(checker)
       listen = reactor.listenTCP(0, pb.PBServerFactory( portal))
       listen.startListening()
       reactor.callFromThread(reactor.wakeUp)
       if otask:
          otask.listen = listen
          otask.ohost = otask.listen.getHost().host
          otask.port = otask.listen.getHost().port
          if self.verb: print "Listening on", otask.listen.getHost().host, otask.listen.getHost().port
       else:
          self.listen = listen
          print "Listening on", self.listen.getHost().host, self.listen.getHost().port
          reactor.callLater(self.sleeptime,self.CheckListen)
   def Dispatch(self,otasks):
       if otasks:
          ctasks = []
          otask = otasks.pop(0)
          reactor.callInThread(self.Dispatch,otasks)
          if hasattr(self,"listen") and not hasattr(otask,"listen"):
             g = self.listen.getHost()
             otask.ohost = g.host
             otask.port = g.port
          elif "reactor.stop" not in otask.func:
             self.Listening(otask)
          ctask = CopyTask()
          [setattr(ctask,attr,getattr(otask,attr)) for attr in otask.elements if hasattr(otask,attr)]
          ctasks.append(ctask)
          d = self.remote.callRemote("task",ctasks)
          d.addErrback(lambda reason: reason.value)
          d.addCallback(lambda result: self.GetResult(result,otasks))
   def GetResult(self,result,otasks):
       if self.verb: print "Hub received",[otask.taskid for otask in otasks]
       if [otask for otask in otasks if "reactor.stop" in otask.func]:
          self.queued.pop(otask)
          self.connector.disconnect()
#         if "reactor.stop" not in otasks[0].func:
#            reactor.callLater(0,self.ClearTask,otasks)
#            if self.verb: print "Wait for task"
#         elif "reactor.stop" in otasks[0].func:
#            reactor.callLater(0,self.ClearTasks,otasks)
   def WaitForTask(self,otask):
       if not otask.done: return
       if hasattr(otask,"listen"): reactor.callFromThread(otask.listen.stopListening)
#       reactor.callFromThread(self.twaits[otask].stop)
#       reactor.callInThread(self.ClearTask,otask)
   def ClearTasks(self,otasks):
       for otask in otasks:
          if self.verb:
              print "Got the result for task",otask.taskid
          if otask.done:
             if hasattr(otask,"uR"):
#                reactor.callLater(0.1,otask.uR, *otask.uRargs, **otask.uRkw)
                otask.uR(*otask.uRargs, **otask.uRkw)
             if hasattr(otask,"listen"):
                otask.listen.stopListening()
             self.completed.append(otask)
             self.queued.pop(otask)
             self.iq.pop(otask.taskid)
       reactor.callFromThread(reactor.wakeUp)

def AddManhole(user,password,namespace,port,now=0,simple=0):
    if simple:
       f = ShellFactory()
    else:
       checker = InMemoryUsernamePasswordDatabaseDontUse()
       checker.addUser(user,password)
       rlm = TerminalRealm()
       rlm.chainedProtocolFactory = lambda: insults.ServerProtocol( Manhole,namespace=namespace)
       ptl = Portal(rlm, [checker])
       f = ConchFactory(ptl)
    r = reactor.listenTCP(port, f)
    return r

class SpawnTask(pb.Avatar):
   def __init__(self,add_modules=[],add_fmodules=[],IMPORTS={}):
      self.IMPORTS = IMPORTS
      print self.IMPORTS.keys()
      self.pid = os.getpid()
      self.added = []
      self.fadded = []
      self.modules = []
      self.fmodules = []
      if add_modules.split(","): self.modules += add_modules.split(",")
      if add_fmodules.split(","): self.fmodules += add_fmodules.split(",")
   def perspective_lmod(self,smod):
         lmod = cPickle.loads(smod)
         os.chdir(lmod["path"])
         f = open(lmod["name"],"w")
         f.write(lmod["data"])
         f.close()
   def perspective_kill(self,sig=9):
      if hasattr(self,"value") and isinstance(self.value,verbsh) and self.value.perf.poll() == None:
         if sig == None: return self.value.perf.pid
         else: return os.kill(self.value.perf.pid,sig)
      else: return os.kill(self.pid,sig)
   def perspective_load(self):
      loadavg = os.getloadavg()
      return loadavg
   def perspective_task(self,otask):
      tstart = time.time()
      path = otask.path
      print "Changing current working directory to %s." % (path)
      sys.stdout.flush()
      os.chdir(path)
      sys.path = orig_path + [path]
      sys.stdout.flush()
      if self.modules:
         [twisted_import(m,IMPORTS=self.IMPORTS) for m in self.modules if m]
      if self.fmodules:
         [twisted_import(m,"*",IMPORTS=self.IMPORTS) for m in self.fmodules if m]
      if hasattr(otask,"modules"):
         [twisted_import(m,IMPORTS=self.IMPORTS) for m in otask.modules if m]
      if hasattr(otask,"fmodules"):
         [twisted_import(m,"*",IMPORTS=self.IMPORTS) for m in otask.fmodules if m]
      d = threads.deferToThread( self.subperspective_task,otask)
      d.addCallback(lambda result: (os.getloadavg(),otask.taskid,result,True,True))
      d.addErrback(lambda result: (os.getloadavg(),otask.taskid,result.getTraceback(),False,False))
      d.addCallback(lambda result: [(not hasattr(otask,"cleanup") and 1 or eval(getattr(otask,"cleanup"))()),\
              result][1])
      d.addCallback(lambda result: [(not hasattr(otask,"value") and 1 or delattr(otask,"cleanup")),\
              result][1])
      return d
   def subperspective_task(self,otask):
      tstart = time.time()
      print "Got",otask, type(otask.func)
      sys.stdout.flush()
      loadavg = os.getloadavg()
      if type(otask.func) is DictionaryType:
         T = TransportFunction()
         func = otask.func[ otask.func.keys()[0]]
         name,func = T.UnmarshalFunction(func,globals())
      else:
         func = otask.func
      taskid = otask.taskid
      sys.stdout.write("Function=%s\n" % (func))
      sys.stdout.flush()
      print "Evaluating now..."
      sys.stdout.flush()
      self.value = EvalTask(otask)
      if isinstance(self.value,verbsh):
         while self.value.perf.poll() == None:
           time.sleep(0.01)
         value = self.value.perf.poll()
      else:
         value = self.value
      value = cPickle.dumps(value,-1)
      sys.stdout.write("Task %r completed.\n" % (taskid))
      sys.stdout.flush()
      return value

class FunctionRealm:
    implements(IRealm)
    def __init__(self,modules,fmodules):
       self.modules = modules
       self.fmodules = fmodules
       self.spawn = SpawnTask(self.modules,self.fmodules,IMPORTS)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.spawn, lambda : None
        else:
            raise NotImplementedError("no interface")

class WatchTask(pb.Avatar):
   def __init__(self,task):
      self.task = task
   def perspective_kill(self,sig=9):
     if hasattr(self.task,"value") and isinstance(self.task.value,verbsh) and self.task.value.perf.poll() == None:
        usepid = self.task.value.pid
     else:
        usepid = self.task.pid
     if sig == None: return usepid
     else: return os.kill(usepid,sig)
   def perspective_load(self):
     loadavg = os.getloadavg()
     return loadavg
   def perspective_stop(self):
     reactor.callLater(1,reactor.callFromThread,reactor.stop)
     return True

class WatchRealm:
    implements(IRealm)
    def __init__(self,realm):
       self.watch = WatchTask(realm.spawn)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.watch, lambda : None
        else:
            raise NotImplementedError("no interface")


def CleanMachines(machines,uid=getpass.getuser()):
    machines = list(sets.Set(machines))
    return TwistedHub([],verb=0,clean=1,wait=1,norun=1,machines=machines,uid=uid,namespace=globals(),nice=0)


